summaryrefslogtreecommitdiffstats
path: root/package/base-files/files/lib/network/config.sh
diff options
context:
space:
mode:
authorjow <jow@3c298f89-4303-0410-b956-a3cf2f4a3e73>2010-06-01 21:43:52 +0000
committerjow <jow@3c298f89-4303-0410-b956-a3cf2f4a3e73>2010-06-01 21:43:52 +0000
commit85773b84bec362be8f137e51d6c373259675c153 (patch)
treed2b45c424efe67daa70ddc192150289cecf0770a /package/base-files/files/lib/network/config.sh
parentd7580992a0b501b1626023fe98eb0b3c746dd5df (diff)
[package] base-file: move alias setup to route hotplug, this fixes alias sections for non-static interfaces like ppp, dhcp, 6in4 etc.
git-svn-id: svn://svn.openwrt.org/openwrt/trunk@21652 3c298f89-4303-0410-b956-a3cf2f4a3e73
Diffstat (limited to 'package/base-files/files/lib/network/config.sh')
-rwxr-xr-xpackage/base-files/files/lib/network/config.sh52
1 files changed, 16 insertions, 36 deletions
diff --git a/package/base-files/files/lib/network/config.sh b/package/base-files/files/lib/network/config.sh
index 1bb3a46ec..a31e83688 100755
--- a/package/base-files/files/lib/network/config.sh
+++ b/package/base-files/files/lib/network/config.sh
@@ -275,49 +275,47 @@ setup_interface_alias() {
}
setup_interface() {
- local iface_main="$1"
+ local iface="$1"
local config="$2"
local proto="$3"
local vifmac="$4"
- local ip6addr_main=
[ -n "$config" ] || {
- config=$(find_config "$iface_main")
+ config=$(find_config "$iface")
[ "$?" = 0 ] || return 1
}
- prepare_interface "$iface_main" "$config" "$vifmac" || return 0
+ prepare_interface "$iface" "$config" "$vifmac" || return 0
- [ "$iface_main" = "br-$config" ] && {
+ [ "$iface" = "br-$config" ] && {
# need to bring up the bridge and wait a second for
# it to switch to the 'forwarding' state, otherwise
# it will lose its routes...
- ifconfig "$iface_main" up
+ ifconfig "$iface" up
sleep 1
}
# Interface settings
- grep "$iface_main:" /proc/net/dev > /dev/null && {
+ grep "$iface:" /proc/net/dev > /dev/null && {
local mtu macaddr
config_get mtu "$config" mtu
config_get macaddr "$config" macaddr
- [ -n "$macaddr" ] && $DEBUG ifconfig "$iface_main" down
- $DEBUG ifconfig "$iface_main" ${macaddr:+hw ether "$macaddr"} ${mtu:+mtu $mtu} up
+ [ -n "$macaddr" ] && $DEBUG ifconfig "$iface" down
+ $DEBUG ifconfig "$iface" ${macaddr:+hw ether "$macaddr"} ${mtu:+mtu $mtu} up
}
- set_interface_ifname "$config" "$iface_main"
+ set_interface_ifname "$config" "$iface"
[ -n "$proto" ] || config_get proto "$config" proto
case "$proto" in
static)
- config_get ip6addr_main "$config" ip6addr
- setup_interface_static "$iface_main" "$config"
+ setup_interface_static "$iface" "$config"
;;
dhcp)
- local lockfile="/var/lock/dhcp-$iface_main"
+ local lockfile="/var/lock/dhcp-$iface"
lock "$lockfile"
# prevent udhcpc from starting more than once
- local pidfile="/var/run/dhcp-${iface_main}.pid"
+ local pidfile="/var/run/dhcp-${iface}.pid"
local pid="$(cat "$pidfile" 2>/dev/null)"
if [ -d "/proc/$pid" ] && grep -qs udhcpc "/proc/${pid}/cmdline"; then
lock -u "$lockfile"
@@ -330,45 +328,27 @@ setup_interface() {
config_get clientid "$config" clientid
[ -z "$ipaddr" ] || \
- $DEBUG ifconfig "$iface_main" "$ipaddr" ${netmask:+netmask "$netmask"}
+ $DEBUG ifconfig "$iface" "$ipaddr" ${netmask:+netmask "$netmask"}
# don't stay running in background if dhcp is not the main proto on the interface (e.g. when using pptp)
local dhcpopts
[ ."$proto1" != ."$proto" ] && dhcpopts="-n -q"
- $DEBUG eval udhcpc -t 0 -i "$iface_main" ${ipaddr:+-r $ipaddr} ${hostname:+-H $hostname} ${clientid:+-c $clientid} -b -p "$pidfile" ${dhcpopts:- -O rootpath -R &}
+ $DEBUG eval udhcpc -t 0 -i "$iface" ${ipaddr:+-r $ipaddr} ${hostname:+-H $hostname} ${clientid:+-c $clientid} -b -p "$pidfile" ${dhcpopts:- -O rootpath -R &}
lock -u "$lockfile"
fi
;;
none)
- setup_interface_none "$iface_main" "$config"
+ setup_interface_none "$iface" "$config"
;;
*)
if ( eval "type setup_interface_$proto" ) >/dev/null 2>/dev/null; then
- eval "setup_interface_$proto '$iface_main' '$config' '$proto'"
+ eval "setup_interface_$proto '$iface' '$config' '$proto'"
else
echo "Interface type $proto not supported."
return 1
fi
;;
esac
- [ "$proto" = none ] || {
- for ifn in `ifconfig | grep "^$iface_main:" | awk '{print $1}'`; do
- ifconfig "$ifn" down
- done
- }
-
- local aliases
- config_set "$config" aliases ""
- config_set "$config" alias_count 0
- config_foreach setup_interface_alias alias "$config" "$iface_main"
- config_get aliases "$config" aliases
- [ -z "$aliases" ] || uci_set_state network "$config" aliases "$aliases"
-
- # put the ip6addr back to the beginning to become the main ip again
- [ -z "$ip6addr_main" ] || {
- $DEBUG ifconfig "$iface_main" del "$ip6addr_main"
- $DEBUG ifconfig "$iface_main" add "$ip6addr_main"
- }
}
stop_interface_dhcp() {